import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyVetoException;
import java.util.PriorityQueue;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;

public class Desktop implements MouseListener{
	private JDesktopPane desktop;
	private Iconsi pManager;
	private Iconsi pManagerS;
	private int i = 0; //Mouse Clicks
	private int xoff = 10;
	private int yoff = 10;
	private PriorityQueue<Application> taskList1,taskList2;
	
	public Desktop(PriorityQueue<Application> t1, PriorityQueue<Application> t2)
	{
		taskList1 = t1;//Assign the two queue lists.
		taskList2 = t2;
		//Create a new Desktop
		desktop = new JDesktopPane();
		desktop.setLayout(null);//No Layouts because we are using an Icon and want exact positions.
		desktop.setBackground(Color.GRAY);
		desktop.setSize(620, 480);
		desktop.setFocusable(true);//Should be focused.
		
		Insets insets = desktop.getInsets();
		
		//Creates our Icons, Selected and unselected.
		pManager = new Iconsi("pmanager.png");
		pManagerS = new Iconsi("pmanagerselected.png");
		
		//Add the mouse listener to them.
		pManagerS.addMouseListener(this);
		pManager.addMouseListener(this);
		
		//Used Dimension for each to set the size.
		Dimension size = pManager.getPreferredSize();
		Dimension size2 = pManagerS.getPreferredSize();
		
		//Sets bounds so its in the spot we want.
		pManager.setBounds(25 + insets.left, 280 + insets.top,
	             size.width, size.height);
		pManagerS.setBounds(25 + insets.left, 280 + insets.top,
	             size2.width, size2.height);
		
		desktop.add(pManager);
		desktop.setVisible(true);
	}
	public JDesktopPane desktop()
	{
		return desktop;
	}
	@Override
	public void mouseClicked(MouseEvent arg0) {
		
		
	}
	@Override
	public void mouseEntered(MouseEvent e) {
		//Creates the hover effect and adds the selected icon when hovered over.
		if(e.getSource() == pManager)
		{
			desktop.remove(pManager);
			desktop.add(pManagerS);
			desktop.repaint();
			desktop.revalidate();
		}
		
	}
	@Override
	public void mouseExited(MouseEvent e) {
		//If the mouse leaves it sets the icon back.
		if(e.getSource() == pManagerS)
		{
			if(i==2||i==0)
			{
			desktop.remove(pManagerS);
			desktop.add(pManager);
			desktop.repaint();
			desktop.revalidate();
			}
		}
		
	}
	public void seti(int i)
	{	//sets it back if the user clicks on the background
		this.i = i;
		if(pManagerS.isShowing())
		{
		desktop.remove(pManagerS);
		desktop.add(pManager);
		desktop.revalidate();
		}
	}
	@Override
	public void mousePressed(MouseEvent e) {
		//If mouse is pressed and = 2 clicks. Create a Program Manager, make it selected/focused and set i back to 0.
		if(e.getSource() == pManagerS)
		{ 
			i = i +1;
			if(i==2)
			{
				JInternalFrame frame = CreateFrame();
				desktop.add(frame);
				try {
					frame.setSelected(true);
				} catch (PropertyVetoException e1) {
					e1.printStackTrace();
				}
				i = 0;
			}
			
		}
		
	}
	@Override
	public void mouseReleased(MouseEvent arg0) {
		
	}
	
	public JInternalFrame CreateFrame()
	{
		//create frame loads a new program manager, sets it 10 off from the existing one and passed the task lists and the desktop.
			Programs pm = new Programs(desktop, taskList1, taskList2);
	        pm.setLocation(xoff, yoff);
	        xoff += 10;
	        yoff += 10;
	        pm.setVisible(true);
			return pm;
	}
}
