import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.PriorityQueue;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.Timer;

import net.miginfocom.swing.MigLayout;

//Engine: Implements Mouse Listener and ActionListener

public class Engine implements MouseListener,ActionListener{
	private int delay = 1000; //milliseconds
	private JFrame window;
	private Desktop d;
	private startup s;
	private Border border;
	private JLabel start;
	private Speaker startup;
	private Speaker tada;
	//Create the queues at the beginning layer of the program. This way it's always the same queue being pulled up in the task manager.
	private PriorityQueue<Application> taskList1,taskList2;
	public void start()
	{
		//create the queues, add the apps
		taskList1 = new PriorityQueue<Application>(1000, new PriorityComparator());
		taskList2 = new PriorityQueue<Application>(1000, new PriorityComparator());
		
		Application app1 = new Application("Solitaire",10);
		Application app2 = new Application("Notepad",5);
		Application app3 = new Application("Firefox",1);

		taskList1.add(app1);
		taskList1.add(app2);
		taskList1.add(app3);
		
		//Create an Object of the Border class
		border = new Border();
		//Create a object of the desktop class, passing in the two lists created above.
		d = new Desktop(taskList1, taskList2);
		//Create the startup animation object.
		s = new startup();
		
		//Create the two sound files used in the intro.
		startup = new Speaker("cb.wav", true);
		tada = new Speaker("tada.wav", false);
		//start the sound
		startup.start();
		
		//Creates the Window using the window method.
		window = window();
		//add the borders using MigLayout Manager and the Borders class functions.
		window.add(border.north(), "north");
		window.add(border.south(), "dock south");
		window.add(border.east(), "dock east, width 8");
		window.add(border.west(), "dock west, width 8");
		
		//Starts the animation
		start = new JLabel(s.start());
		window.getContentPane().add(start, "dock center");
		window.setVisible(true);

		while(true)
		{
			//Create the Timer using the delay, and actionlistener
			new Timer(delay, this).start();
			//Stop the sound when it gets past a certain point in the sound file.
			if(startup.getLong() >= 646657)
			{
				//remove the start animation
				window.remove(start);
				//add the desktop
				window.add(d.desktop(), "dock center");
				//repaint components and revalidate them.
				window.repaint();
				window.validate();
				//stop the startup song
				startup.stop();
				//play tada sound file
				tada.start();
				//kill the loop
				break;
			}

		}
	}

	//This creates the window or the "Frame" that the program uses for its "window"
	public JFrame window()
	{
		window = new JFrame();
		window.setSize(738, 448);
		window.setLocationRelativeTo(null);//Centers the JFrame.
		window.setUndecorated(true);//Turn off the JFrame borders.
		window.setLayout(new MigLayout());
		window.addMouseListener(this);
		return window;
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {
		d.seti(0); //i = click count
		if(arg0.getX() <= 732 && arg0.getX() >= 718)
		{
			if(arg0.getY() <= 22 && arg0.getY()>=7)
			{
				//If mouse clicks in a certain point on the frame, kill it. In this case its the upper right corner, the x.
				System.exit(0);
			}

		}

	}

	@Override
	public void mouseEntered(MouseEvent arg0) {

	}

	@Override
	public void mouseExited(MouseEvent arg0) {

	}

	@Override
	public void mousePressed(MouseEvent arg0) {

	}

	@Override
	public void mouseReleased(MouseEvent arg0) {

	}

	@Override
	public void actionPerformed(ActionEvent e) {

	}

}
