import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyVetoException;
import java.util.PriorityQueue;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.plaf.ColorUIResource;

import net.miginfocom.swing.MigLayout;


public class List extends JPanel implements MouseListener, ChangeListener{

	private static final long serialVersionUID = 1L;
	private JPanel pList;
	private JPanel pPriority;
	private JButton newTask;
	private JButton kill;
	private JList plist,nlist;
	private DefaultListModel lm,pm;
	private TitledBorder tskn,tskp;
	private Color inactive,active;
	private Border blackline;
	private PriorityQueue<Application> taskList1,taskList2;
	private int h;
	private int w;
	private int tasksize;
	private int priorityval;
	private JSlider ppicker;
	private JDesktopPane d;
	private JInternalFrame f;
	private JButton create;
	private JTextField text;
	private int rotation = 1;
	//Passes Desktop, and the queues.
	public List(JDesktopPane d, PriorityQueue<Application> t1, PriorityQueue<Application> t2)
	{
		this.d = d;
		taskList1 = t1;
		taskList2 = t2;
		text = new JTextField();
		
		pList = new JPanel();
		pList.setBackground(Color.white);
		pList.addMouseListener(this);
		inactive=new Color(94,108,67);
		active= new Color(150,174,108);
		blackline = BorderFactory.createLineBorder(Color.black);

		pPriority = new JPanel();
		newTask = new JButton("New Task");
		kill = new JButton("Kill Task");
		kill.addMouseListener(this);
		newTask.addMouseListener(this);

		//Create oru list Models.
		lm = new DefaultListModel();
		pm = new DefaultListModel();
		
		//Create the lists and priority lists.
		list();
		priority();
		
		this.setBackground(Color.white);
		this.setLayout(new MigLayout());
		this.add(pList, "width 110, cell 0 0");
		this.add(pPriority, "width 85, cell 1 0, wrap");
		//Only allow a new task if its under 9
		if(tasksize <= 9)
		{
			this.add(newTask, "gaptop 20");
		}
		this.add(kill, "");
		this.setSize(w, h);
		this.setVisible(true);
	}

	public void list()
	{
		tskn = BorderFactory.createTitledBorder(blackline, "Task Name");//Add a cool border around the lists.
		tskn.setTitleJustification(TitledBorder.CENTER);//Center the title
		lm.clear();//clear the list modules.
		pm.clear();
		
		//Rotation: This makes it so when the list prints out and gets put in the list models, the queues content, is not removed but put into
		//another queue called taskList2. so Rotation rotates the two queues around keeping the queues content.
		if(rotation == 1)
		{
			taskList2.addAll(taskList1);
			tasksize = taskList2.size();
			while(taskList1.size() > 0 ) {
				
				Application application = (Application) taskList1.remove();
				lm.addElement(application.getName());
				pm.addElement(application.getPriority());				
			}
			rotation = 2;
		}
		else if(rotation == 2)
		{
			taskList1.addAll(taskList2);
			tasksize = taskList1.size();
			while(taskList2.size() > 0 ) {
				Application application = (Application) taskList2.remove();
				lm.addElement(application.getName());
				pm.addElement(application.getPriority());
			}
			rotation = 1;
		}
		nlist = new JList(lm);

		h = 300;
		w = 205;
		nlist.setSize(w, h);
		nlist.setVisible(true);
		pList.add(nlist);
		pList.setBorder(tskn);
		pList.setVisible(true);
	}

	public void priority()
	{
		tskp = BorderFactory.createTitledBorder(
				blackline, "Priority");
		tskp.setTitleJustification(TitledBorder.CENTER);
		plist = new JList(pm);
		plist.setVisible(true);
		pPriority.setBackground(Color.white);
		pPriority.add(plist);
		pPriority.setBorder(tskp);
		pPriority.setVisible(true);
	}

	public JInternalFrame newtaskwindow()
	{
		//Create the New Task Window
		JInternalFrame f = new JInternalFrame();
		f.setBorder(BorderFactory.createLineBorder(Color.black));
		UIManager.put("InternalFrame.activeTitleBackground", new ColorUIResource(active));
		UIManager.put("InternalFrame.inactiveTitleBackground", new ColorUIResource(inactive));
		javax.swing.plaf.basic.BasicInternalFrameUI ui = new javax.swing.plaf.basic.BasicInternalFrameUI(f); f.setUI(ui); 
		f.setSize(220,150);
		f.setLocation(210,100);
		f.setClosable(true);
		f.setResizable(true);
		f.setIconifiable(true);
		f.setTitle("New Task");
		f.add(nPanel());
		f.setVisible(true);
		return f;
	}

	public JPanel nPanel()
	{
		//The is the Gui of the New Task Window
		JPanel p = new JPanel();
		p.setBackground(Color.white);

		JLabel name = new JLabel("Task Name: ");
		ppicker = new JSlider(JSlider.HORIZONTAL, 1, 100, 1);
		text.setSize(100,20);
		text.setVisible(true);
		JLabel plabel = new JLabel("Pick Priority of Task, 1 is Greatest");
		ppicker.setPaintLabels(true);
		ppicker.setPaintTicks(true);
		ppicker.setPaintTrack(true);
		ppicker.addChangeListener(this);
		ppicker.setMajorTickSpacing(10);
		ppicker.setMinorTickSpacing(1);
		ppicker.setVisible(true);
		create = new JButton("Create Task");
		create.addMouseListener(this);
		p.setLayout(new MigLayout());
		p.add(name, "cell 0 0");
		p.add(text, "width 100, cell 1 0");
		p.add(plabel, "span 2, cell 0 1");
		p.add(ppicker, "span 2, cell 0 2");
		p.add(create, "gapleft 50, span 2, cell 0 3");
		p.setVisible(true);
		return p;
	}
	
	public void update()
	{
		//When Update is ran, it removes everything on the task list window, runs list and priority, adds them, allows the new task button
		//if its under 9 in the queue, repaints and revalidates.
		pList.remove(nlist);
		pPriority.remove(plist);
		pList.validate();
		pPriority.validate();
		this.remove(kill);
		this.remove(newTask);
		this.remove(pList);
		this.remove(pPriority);
		this.revalidate();
		this.repaint();
		list();
		priority();
		this.add(pList, "width 110, cell 0 0");
		this.add(pPriority, "width 85, cell 1 0, wrap");
		if(tasksize <= 9)
		{
			this.add(newTask, "gaptop 20");
		}
		this.add(kill, "");
		this.repaint();
		this.revalidate();
		d.repaint();
	}
	@Override
	public void mouseClicked(MouseEvent e) {
		//Creates a new task window and makes it focused.
		if(e.getSource() == newTask)
		{
			f = newtaskwindow();
			d.add(f);
			d.validate();
			try {
				f.setSelected(true);
			} catch (PropertyVetoException e1) {
				e1.printStackTrace();
			}
		}
		else if(e.getSource() == kill)
		{
			//removes a queue based on the rotation its on.
			if(rotation == 1)
			{
				taskList1.poll();
				
			}
			else if(rotation == 2)
			{
				taskList2.poll();
			}
				update();//Runs the Update method
		}

		if(e.getSource() == create)
		{
			//sets a 0 priority to be 1.
			if(priorityval == 0)
			{
				priorityval = 1;
			}
			Application app = new Application(text.getText(), priorityval);
			
			//adds task based on rotation
			if(rotation == 1)
			{
			taskList1.add(app);
			}
			else if(rotation == 2)
			{
				taskList2.add(app);
			}
			//updates
			update();
			//disposes the create window.
			f.dispose();
		}
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {

	}

	@Override
	public void mouseExited(MouseEvent arg0) {

	}

	@Override
	public void mousePressed(MouseEvent e) {


	}

	@Override
	public void mouseReleased(MouseEvent arg0) {

	}

	@Override
	public void stateChanged(ChangeEvent e) {
		if(e.getSource() == ppicker)
		{
			priorityval = ppicker.getValue();
		}

	}
}
