import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyVetoException;
import java.util.PriorityQueue;

import javax.swing.BorderFactory;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.plaf.ColorUIResource;


public class Programs extends JInternalFrame implements MouseListener{

	private static final long serialVersionUID = 1L;
	private JPanel content;
	private Component taskmanager;
	private Color inactive,active;
	private Iconsi tskmngr= new Iconsi("taskmanager.png");
	private Iconsi tskmngrs= new Iconsi("taskmanagerselected.png");
	private JDesktopPane D;
	private JInternalFrame frame;
	private int i,n = 0;
	private JInternalFrame tm;
	private PriorityQueue<Application> taskList1,taskList2;
	private int xoff, yoff = 0;
	
	//Pass desktop, and the queues
	public Programs(JDesktopPane desktop, PriorityQueue<Application> t1, PriorityQueue<Application> t2){
		taskList1 = t1;
		taskList2 = t2;
		D = desktop;
		tm = new JInternalFrame();
		inactive=new Color(94,108,67);//colors for the windows theme.
		active= new Color(150,174,108);
		
		//creates the JInternalFrame "Program Manager"
		setTitle("Program Manager");
		setSize(400, 200);
		setAutoscrolls(true);
		setClosable(true);
		setResizable(true);
		setDoubleBuffered(true);
		setIconifiable(true);
		setBorder(BorderFactory.createLineBorder(Color.black));
		taskmanager = Content();
		add(taskmanager);
		setMaximizable(true);
		UIManager.put("InternalFrame.activeTitleBackground", new ColorUIResource(active));
		UIManager.put("InternalFrame.inactiveTitleBackground", new ColorUIResource(inactive));
		javax.swing.plaf.basic.BasicInternalFrameUI ui = new javax.swing.plaf.basic.BasicInternalFrameUI(this);//creates a UI for our frame with our colors.
		this.setUI(ui);//set our ui
		setVisible(true);

	}	

		//This is the content inside the Program Manager
	public Component Content()
	{

		content = new JPanel();
		content.setLayout(null);
		Insets insets = content.getInsets();
		Dimension size = tskmngr.getPreferredSize();
		tskmngr.setBounds(25 + insets.left, 10 + insets.top,
				size.width, size.height);
		tskmngr.addMouseListener(this);
		tskmngrs.addMouseListener(this);
		tskmngrs.setBounds(25 + insets.left, 10 + insets.top,
				size.width, size.height);
		content.setBackground(Color.white);
		content.add(tskmngr);
		content.setSize(400, 400);
		content.setVisible(true);
		return content;

	}

	//This creates a taskManager window and uses the List class.
	public JInternalFrame taskManager(int xoff, int yoff)
	{
		//Passes Desktop and queues.
		List l = new List(D, taskList1, taskList2);
		Dimension minSize = new Dimension(l.getSize());
		inactive=new Color(94,108,67);
		active= new Color(150,174,108);
		tm.setTitle("Task Manager");
		tm.setSize(minSize);
		tm.setAutoscrolls(true);
		tm.setClosable(true);
		tm.setDoubleBuffered(true);
		tm.setIconifiable(true);
		tm.setLocation(xoff, yoff);
		tm.setBackground(Color.white);
		tm.add(l);
		tm.setBorder(BorderFactory.createLineBorder(Color.black));
		UIManager.put("InternalFrame.activeTitleBackground", new ColorUIResource(active));
		UIManager.put("InternalFrame.inactiveTitleBackground", new ColorUIResource(inactive));
		javax.swing.plaf.basic.BasicInternalFrameUI ui = new javax.swing.plaf.basic.BasicInternalFrameUI(tm); tm.setUI(ui); 
		tm.setVisible(true);
		return tm;
	}
	@Override
	public void mouseClicked(MouseEvent e) {
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		if(e.getSource() == tskmngr)
		{
			content.remove(tskmngr);
			content.repaint();
			content.revalidate();
			content.add(tskmngrs);
			content.repaint();
			content.revalidate();
		}

	}

	@Override
	public void mouseExited(MouseEvent e) {
		if(e.getSource() == tskmngrs)
		{
			if(i==2||i==0)
			{
				content.remove(tskmngrs);
				content.add(tskmngr);
				content.repaint();
				content.revalidate();
			}
		}

	}

	@Override
	public void mousePressed(MouseEvent e) {
		
		//if user clicks twice on the icon it opens a new task manager, with an offset. 
		//It also removes the frame and opens it again if you try and open another one.
		int t = 0;
		if(e.getSource() == tskmngrs)
		{
			t++;
			xoff += 10;
			yoff += 10;
			n = n +1;
			if(n==2)
			{
				frame = taskManager(xoff,yoff);
				try{
					D.remove(frame);
					D.validate();
				}
				catch(Exception b)
				{
					
				}
				D.add(frame);
				D.validate();
				try {
					frame.setSelected(true);
				} catch (PropertyVetoException e1) {
					e1.printStackTrace();
				}
				n = 0;
			}
		}
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {

	}
}
