import java.io.File;
import java.io.IOException;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;


public class Speaker {
	private Clip clip = null;
	private boolean loop = false;
	//Constructor
	public Speaker(String filename, boolean loop) {
		this.loop = loop;//Loop the sound?
		
		//Loads the sound file in the sound folder and the string that was passed.
		File soundFile = new File("sounds/" + filename);
		//Create a empty AudioInputStream
		AudioInputStream soundIn = null;
		
		try {
			soundIn = AudioSystem.getAudioInputStream(soundFile);//Tries to get the soundfile.
		} catch (UnsupportedAudioFileException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		AudioFormat format = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, AudioSystem.NOT_SPECIFIED, 16, 2, 4, AudioSystem.NOT_SPECIFIED, true);//Create an AudioFormat
		DataLine.Info info = new DataLine.Info(Clip.class, format);//Create a dataline based off the format

		
		try {
			clip = (Clip)AudioSystem.getLine(info);//Try to create a clip based off the DataLine
		} catch (LineUnavailableException e) {
			e.printStackTrace();
		}
		try {
			clip.open(soundIn);//Try and open that sound file using our Clip
		} catch (LineUnavailableException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	//Call this to stop the clip
	public void stop()
	{
		clip.stop();
	}
	//Start the sound and loop if its set.
	public void start()
	{
		clip.start();
		if(loop)
		{
			clip.loop(100);
		}
	}
	//returns position of song.
	public Long getLong()
	{
		return clip.getLongFramePosition();
	}

}
